// package JavaCode;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;

public class Consensus {
	static final int[] dPoint     = {13800, 13500};
	static final int[] lMoniter   = {55, 55};
	static final int circuleSize  = 2000;
	static final int s0s1Gap      = 20;
	static final String[] ddd     = {"=", ">", "<"}; 
	static final int TTL          = 0;
	static final int F            = 1;
	static final int R            = 2;
	static final int A            = 0;          // 
	static final int C            = 1;          // 
	static final int G            = 2;          // 
	static final int T            = 3;          // 
	static final int N            = 4;          // 
	static final int[]  comp      = {T, G, C, A, N}; // used to convert int bp to its complement int
	static final char[][][][] baseCode = {{{{'N', 'T'}, {'G', 'K'}}, {{'C', 'Y'}, {'S', 'B'}}}, {{{'A', 'W'}, {'R', 'D'}}, {{'M', 'H'}, {'V', 'N'}}}};
	private static double[][][] prbCal = new double[2][93][81];
	public  static float[][]  iq2prb  = new float[93][81];
	private static int[][]    iq2qCal = new int[93][81];
	private static float[]    q2prb   = new float[81];
	public  static int[][]    snpScoreHist = new int[4][101];
	public  static int[][][]  snpScoreBidx = new int[2][15][101];
	
	// BufferedReader reader;
	static OligoFile of;
	static Oligo     ol;
	static DataInputStream strInPrb;
	static int start;
	private static Seq seq;
	
	public class circularMap {
		private int[] sumBasesEdges       = {0, 0, 0};
		private int[] countLocationdEdges = {0, 0, 0};
		private int[] edgeStart           = {s0s1Gap, s0s1Gap, s0s1Gap};
		public float[] bidx;
		public int[]   info;
		public int[]   sGap;
		public int[]   sGapCnt;
		public int[]   cntSet;
		public int[][] cnt;
		public int[][] scnt;
		public byte[]  refMap;
		public byte[]  bestQ2;
		public char[]  bestQBase2;
		public byte[]  bestQ1;
		public char[]  bestQBase1;
		public int[][] lqb;
		public int[] snpNeighborhood;
		public double[][][] p;
		public double[][] ref_p;
		public int[][]  maxRef4;
		public int[][]  maxDat4;
		private float[] buff = new float[4];
		private int[] start = new int[3];
		private float w;
		private float wNot;
		private int counter = 0;
		private int oldStart = 0;
		DataOutputStream dos    = null;
		DataInputStream  dis    = null;
		DataInputStream  disMap = null;
		BufferedWriter writerEdges;
		BufferedWriter writerSNPs;
		BufferedWriter writerCoverage;
		String outFile;
		
		public circularMap(String fName) {
			sGap    = new int[circuleSize];
			sGapCnt = new int[circuleSize];
			bidx    = new float[circuleSize];
			info    = new int[circuleSize];
			refMap  = new byte[circuleSize];
			bestQ2  = new byte[circuleSize];
			bestQBase2 = new char[circuleSize];
			bestQ1  = new byte[circuleSize];
			bestQBase1 = new char[circuleSize];
			cnt     = new int[3][circuleSize];
			scnt    = new int[3][circuleSize];
			cntSet  = new int[circuleSize];
			lqb     = new int[3][circuleSize];
			snpNeighborhood = new int[circuleSize];
			p       = new double[3][4][circuleSize];
			ref_p   = new double[4][circuleSize];
			maxRef4 = new int[4][circuleSize];
			maxDat4 = new int[4][circuleSize];
			counter  = 0;
			start[0] = start[1] = s0s1Gap;
			start[2] = 0;
			clean(0, circuleSize);
			outFile = Parameters.pathOut + fName; 
			try {
		    	String mapFl = Parameters.pathDB + Parameters.DATABASE + fName + ".map.36";
				if (Parameters.storeConsensus)
					dos = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(outFile + ".consensus"), Parameters.buffSize));
				dis = new DataInputStream(new BufferedInputStream(new FileInputStream(Parameters.pathDB + Parameters.refSNPs + fName + ".pRef"), Parameters.buffSize));
		    	disMap = new DataInputStream(new BufferedInputStream(new FileInputStream(mapFl), 127000));
				// refMap[i] = strIns.readByte();

				writerEdges    = new BufferedWriter(new FileWriter(outFile + ".edges"));
				writerSNPs     = new BufferedWriter(new FileWriter(outFile + ".snps"));
				if (Parameters.storeCoverage)
					writerCoverage = new BufferedWriter(new FileWriter(outFile + ".coverage"));
			} catch (Exception e) {
				System.err.println("Can not open output file:\t" + outFile + "\n" + e);
			}
			for (int i = 0; i < 100; i++) {
				int cmidx = cmIndex(i);
				try { // load ref_prbs from database
					maxRef4[0][cmidx] = dis.readByte();
					maxRef4[1][cmidx] = dis.readByte();
					maxRef4[2][cmidx] = dis.readByte();
					maxRef4[3][cmidx] = dis.readByte();
					for (int b = 0; b < 4; b++) {
						ref_p[b][cmidx] = dis.readFloat();
						// sum += ref_p[b][start[0]];
					}
				} catch (Exception e) {
					
				}
			}

		}
		
		private void clean (int st, int en) {
			if (en > st) {
				for (int i = st; i < en; i++) {
					bidx[i]    = 0;
					bestQ1[i]  = 0;
					bestQBase1[i] = '-';
					bestQ2[i]  = 0;
					bestQBase2[i] = '-';
					info[i]    = 0;
					sGap[i]    = 0;
					sGapCnt[i] = 0;
					snpNeighborhood[i] = 0;
					for (int j = 0; j < 3; j++) {
						cnt[j][i] = 0;
						scnt[j][i] = 0;
						lqb[j][i] = 0;
						for (int b = 0; b < 4; b++) {
							p[j][b][i] = 0.25;
						}
					}
				}	
			} else if (en < st) {
				clean (0, en);
				clean (st, circuleSize);
			}
		}

		public void loadBuffQ(byte qa, byte qc, byte qg, byte qt) {
			buff[A] = q2p(qa) * w + wNot;
			buff[C] = q2p(qc) * w + wNot;
			buff[G] = q2p(qg) * w + wNot;
			buff[T] = q2p(qt) * w + wNot;
			float sumBuff = buff[A] + buff[C] + buff[G] + buff[T];
			for (int b = 0; b < 4; b++) {
				buff[b] = buff[b] / sumBuff;
			}
		}
		
		private boolean writeStartPoint0() throws Exception {
			int oldStart2;
			/*
			if (counter >= ol.start) {
				return false;
			} //*/
			/*
			if (ol.start > 180837000) { //180700000
				System.err.println(counter + "\t" + start[0] + "\t" + ol);
				// System.out.println(counter + "\t" + ol);
			} //*/
			try {
				refMap[start[0]]     = disMap.readByte();
			} catch (Exception e) {
				// System.err.println("Out of map Size:\tcounter\t" + counter + "\tol.start\t" + ol.start + "\tstart[0]\t" + start[0]);
				refMap[start[0]]     = 36;
				// Thread.sleep(50);
			}
			if (Parameters.storeCoverage)
				writerCoverage.write(counter + "\t" + start[0] + "\t" + cnt[TTL][start[0]] + "\t" + cntSet[start[0]] + "\t" + 
						refMap[start[0]] + "\t" + 
						sGapCnt[start[0]] + "\t" + 
						Parameters.trim((double) sGap[start[0]] / sGapCnt[start[0]]) + 
						"\n");
			if (Parameters.storeConsensus) {
				for (int d = 0; d < 3; d++) {
					if (d == TTL) {
						dos.writeInt(sGap[start[0]]);
						dos.writeInt(sGapCnt[start[0]]);
						dos.writeFloat(bidx[start[0]]);
					}
					dos.writeInt(cnt[d][start[0]]);
					for (int b = 0; b < 4; b++) {
						dos.writeFloat((float) p[d][b][start[0]]);
					}
				}
			}
			counter++;
			double sum = 0;
			double sub;
			int idxb = 0;
			int cmidx = cmIndex(100);
			try { // load ref_prbs from database
				maxRef4[0][cmidx] = dis.readByte();
				maxRef4[1][cmidx] = dis.readByte();
				maxRef4[2][cmidx] = dis.readByte();
				maxRef4[3][cmidx] = dis.readByte();
				for (int b = 0; b < 4; b++) {
					ref_p[b][cmidx] = dis.readFloat();
					// sum += ref_p[b][start[0]];
				}
				for (int b = 0; b < 4; b++) {
					if (ref_p[maxRef4[b][cmidx]][cmidx] > 0.05) {
						idxb = b;
					} else {
						sum += ref_p[maxRef4[b][cmidx]][cmidx];						
					}
				}
				// System.err.println("sum1:\t" + sum);
				if (idxb < 3) {
					sum = sum / (3 - idxb);
					// System.err.println("sum2:\t" + sum);
					for (int i = 3; i > idxb; i--) {
						ref_p[maxRef4[i][cmidx]][cmidx] -= sum;
					}
					sum = Parameters.snpRatio / (3 - idxb);
					// System.err.println("sum3:\t" + sum);
					for (int i = 3; i > idxb; i--) {
						ref_p[maxRef4[i][cmidx]][cmidx] += sum;
					}
					sub = Parameters.snpRatio / (idxb + 1);
					sum = 0;
					for (int i = 0; i <= idxb; i++) {
						sum += ref_p[maxRef4[i][cmidx]][cmidx];
					}
					// System.err.println("sum4:\t" + sum + "\tsub\t:" + sub);
					for (int i = 0; i <= idxb; i++) {
						ref_p[maxRef4[i][cmidx]][cmidx] = ref_p[maxRef4[i][cmidx]][cmidx] / sum - sub;
					}
					sum = 0;
					for (int b = 0; b < 4; b++) {
						sum += ref_p[b][cmidx];
					}
					for (int b = 0; b < 4; b++) {
						ref_p[b][cmidx] = ref_p[b][cmidx] / sum;
					}
				}
			} catch (Exception e) {
				// System.err.println("Out of ref Size:\t" + counter + "\t" + ol.start);
				maxRef4[0][cmidx] = 0;
				maxRef4[1][cmidx] = 1;
				maxRef4[2][cmidx] = 2;
				maxRef4[3][cmidx] = 3;
				for (int b = 0; b < 4; b++) {
					ref_p[b][cmidx] = 0.25;
				}
				// Thread.sleep(50);
			}
			/*
			System.err.println(counter + "\t" + maxRef4[0][start[0]] + "\t" + maxRef4[1][start[0]] + "\t" + 
					ref_p[0][start[0]] + "\t" + ref_p[1][start[0]] + "\t" + 
					ref_p[2][start[0]] + "\t" + ref_p[3][start[0]]);
			Thread.sleep(1000);//*/
			oldStart2 = start[2];
			markSNPs(); // on start[0]
			smoothEdge(); // up to start[1]
			outputEdge();
			writeSNPs(start[2], counter - s0s1Gap);

			if (cnt[TTL][start[0]] > 9) {
				CallSNPs.covered[CallSNPs.chr][9]++;
			} else if (cnt[TTL][start[0]] > 0) {
				CallSNPs.covered[CallSNPs.chr][cnt[TTL][start[0]] - 1]++;
			}
			increaseStart(0, 1);
			increaseStart(2, 1);
			clean(oldStart2, start[2]);
			return true;
		}

		int itr;
		
		private void outputEdge() throws Exception {
			int   countLocation;
			float countBases;
			for (int d = F; d <= R; d++) {
				countLocation = 0;
				countBases = 0;
				if(lqb[d][start[2]] > 0) {
					itr = start[2];
					writerEdges.write((counter - s0s1Gap) + " " + ddd[d] + ":\t");
					while(lqb[d][itr] > 0) {
						countLocation++;
						countBases += cnt[d][itr];
						writerEdges.write(getMPBase(d, itr));
						// snp[d][itr] = false;
						increase();
					}
					writerEdges.write("\t" + Parameters.trim(countBases / countLocation) + "\n");
					itr = start[2];
					writerEdges.write((counter - s0s1Gap) + " R:\t");
					while(lqb[d][itr] > 0) {
						writerEdges.write(getRefMPBase(itr));
						if (!(lqb[TTL][itr] > 0 && snpNeighborhood[itr] < 3 && bidx[itr] < 90))
							lqb[d][itr] = 0;
						increase();
					}
					writerEdges.write("\n");
				}
			} 
		}
		
		private void smoothEdge() {
			for (int direction = F; direction <= R; direction++) {
				if (cnt[direction][start[0]] > 0) {
					sumBasesEdges[direction] += cnt[direction][start[0]];
					countLocationdEdges[direction]++;
				} else {
					if(countLocationdEdges[direction] > 1 &&  countLocationdEdges[direction] < sumBasesEdges[direction]) {
						for(itr = edgeStart[direction]; itr != start[0]; increase()) {
							lqb[direction][itr] = 1;
						}
					}
					sumBasesEdges[direction] = 0;
					countLocationdEdges[direction] = 0;
					edgeStart[direction] = start[0] + 1; 
					if (edgeStart[direction] >= circuleSize) {
						edgeStart[direction] = edgeStart[direction] % circuleSize;
					}

				}
			}
		}
		
		private void markSNPs() throws Exception {
			if(counter > s0s1Gap) {
				if (((scnt[TTL][start[0]] * 3) > (cnt[TTL][start[0]])) && enoughInfo()) {
					if (maxDat4[0][start[0]] != maxRef4[0][start[0]]) { // ------------------------------------ misMatch
						lqb[TTL][start[0]] = 1;
					} else {
						lqb[TTL][start[0]] = 0;
					}
				} else { // ---------------------------------------------------------------- not enough info
					lqb[TTL][start[0]] = 0;
				}
			}
		}
		
		private boolean enoughInfo() {
			int nx = 2;
			if (p[TTL][0][start[0]] >= p[TTL][1][start[0]]) {
				maxDat4[0][start[0]]  = 0;
				maxDat4[1][start[0]]  = 1;
			} else {
				maxDat4[0][start[0]] = 1;
				maxDat4[1][start[0]] = 0;
			}
			for (int b = 2; b < 4; b++) {
				if (p[TTL][b][start[0]] > p[TTL][maxDat4[1][start[0]]][start[0]]) {
					maxDat4[nx][start[0]] = maxDat4[1][start[0]];
					if (p[TTL][b][start[0]] > p[TTL][maxDat4[0][start[0]]][start[0]]) {
						maxDat4[1][start[0]]  = maxDat4[0][start[0]];
						maxDat4[0][start[0]]  = b;
					} else {
						maxDat4[1][start[0]] = b;
					}
				} else {
					maxDat4[nx][start[0]] = b;
				}
				nx++;
			}
			if (ref_p[maxDat4[2][start[0]]][start[0]] < ref_p[maxDat4[3][start[0]]][start[0]]) {
				nx    = maxDat4[2][start[0]];
				maxDat4[2][start[0]] = maxDat4[3][start[0]];
				maxDat4[3][start[0]] = nx;
			}
			if(p[TTL][maxRef4[0][start[0]]][start[0]] < Parameters.noiseBase && 
					!(p[TTL][maxRef4[0][start[0]]][start[0]] < 0.26 && p[TTL][maxRef4[0][start[0]]][start[0]] > 0.24)) { 
				for (int j = -Parameters.noiseWindowSize; j < Parameters.noiseWindowSize; j++) { 
					snpNeighborhood[cmIndex(j)]++;
				}
			}
			double dtmn = p[TTL][maxDat4[2][start[0]]][start[0]] + p[TTL][maxDat4[3][start[0]]][start[0]];
			double rfmn = (1 - ref_p[maxRef4[0][start[0]]][start[0]]) * 2.0 / 3.0; // + ref_p[maxRef4[3][start[0]]][start[0]];
			return rfmn > dtmn; // && p[TTL][maxDat4[2][start[0]]][start[0]];
		}

		public void displayCP(int d, int sp) {
			System.err.println(counter + "\t\t" + Math.round(p[d][0][start[sp]]) + "\t" + Math.round(p[d][1][start[sp]]) + "\t" + 
					Math.round(p[d][2][start[sp]]) + "\t" + Math.round(p[d][3][start[sp]]));			
			System.err.print(maxRef4[0][start[sp]] + "\t" + maxRef4[1][start[sp]] + "\t" + 
					Math.round(ref_p[0][start[sp]]) + "\t" + Math.round(ref_p[1][start[sp]]) + 
					"\t" + Math.round(ref_p[2][start[sp]]) + "\t" + Math.round(ref_p[3][start[sp]]));
			if (lqb[TTL][start[0]] > 0) {
				System.err.println("\tSNP\t" + snpNeighborhood[start[0]] + "\n");
			} else {
				System.err.println("\n");				
			}
		}
		
		private void writeSNPs(int sp, int address) throws Exception {
			double sumMinData = 0;
			double sumMinRef  = 0;
			double sumMinRefK = 0;
			int    countDMin  = 0;
			int    countRMin  = 0;
			int    scorek;
			int    bx;
			int cn;
			if (lqb[TTL][sp] > 0 && snpNeighborhood[sp] < 3) {
				// ----------------------------------------------------------------------------------------------------------
				for(countDMin = 0; countDMin < 4; countDMin++) {
					if(p[TTL][maxDat4[3-countDMin][sp]][sp] < 0.005) {
						sumMinData += p[TTL][maxDat4[3-countDMin][sp]][sp];
					} else
						break;
				}
				for(countRMin = 0; countRMin < 4; countRMin++) {
					if(ref_p[maxRef4[3-countRMin][sp]][sp] < 0.05) {
						sumMinRef  += ref_p[maxRef4[3-countRMin][sp]][sp];
					} else
						break;
				} 
				if (countDMin == 3) {
					// ----------------------------------------------------------------------------------------------------------
					sumMinData = 3 * sumMinData / countDMin;
					sumMinRef  = 3 * sumMinRef  / countRMin;

					sumMinRefK = sumMinRef;
					if (ref_p[maxRef4[0][sp]][sp] < 0.95) {
						sumMinRefK += (1-ref_p[maxRef4[0][sp]][sp]);
					}
					if (sumMinData > 0) {
						scorek   = (int) Math.round(Math.log(sumMinRefK / sumMinData) / Math.log(10)); 
						info[sp] = (int) Math.round(Math.log(sumMinRef / sumMinData) / Math.log(10)); 
					} else {
						scorek   = 100;
						info[sp] = 100;
					}
					if (info[sp] > 100)
						info[sp] = 100;
					else if (info[sp] < 0)
						info[sp] = 0;
					if (scorek > 100)
						scorek = 100;
					if (scorek < 0)
						scorek = 0;
					
					bx = Math.round(bidx[sp] * 100 / cnt[TTL][sp]);
					if (bx > 100)
						bx = 100;
					if (bx < 0)
						bx = 0;

					cn = cnt[TTL][sp];
					if (cn > 14)
						cn = 14;
					CallSNPs.bidxHist[CallSNPs.chr][bx]++;
					CallSNPs.bidxAvr[CallSNPs.chr] += bx;
					CallSNPs.countSnps[CallSNPs.chr]++;
					writerSNPs.write(CallSNPs.countSnps[CallSNPs.chr] + "\t" + address + "\t" + 
							getRefMPBase(sp) + "\t" + getBase(TTL, sp) + "\t" + scorek + "\t" + info[sp] + "\t" + 
							cnt[TTL][sp] + "\t" + scnt[TTL][sp] + "\t" + Math.round(bidx[sp] * 100 / cnt[TTL][sp]) + "\t" + 
							bestQ1[sp] + "\t" + bestQBase1[sp] + "\t" + bestQ2[sp] + "\t" + bestQBase2[sp] + "\t" +
							Math.round(p[TTL][0][sp] * 100) + "\t" + Math.round(p[TTL][1][sp] * 100) + "\t" + 
							Math.round(p[TTL][2][sp] * 100) + "\t" + Math.round(p[TTL][3][sp] * 100));
					if(ref_p[maxRef4[0][sp]][sp] < 0.9) {
						writerSNPs.write("\tKnown");
						snpScoreHist[0][scorek]++;
						snpScoreHist[2][info[sp]]++;
						snpScoreBidx[0][cn][bx]++;
					} else {
						CallSNPs.nSNPsCount[CallSNPs.chr]++;
						writerSNPs.write("\tNovel");
						snpScoreHist[1][scorek]++;
						snpScoreHist[3][info[sp]]++;
						snpScoreBidx[1][cn][bx]++;
					}
					/*
					if(2 * cnt[TTL][sp] < 3 * scnt[TTL][sp]) {
						writerSNPs.write("\tH1");
					} else {
						CallSNPs.hSNPsCount[CallSNPs.chr]++;
						writerSNPs.write("\tH2");// + (4 - countDMin));						
					}
					//*/
					for (int d = F; d <= R; d++) {
						if (lqb[d][itr] > 0) {
							writerSNPs.write("\tEdge");
							lqb[d][itr] = 0;
						}
					}
					writerSNPs.write("\n");
					// ----------------------------------------------------------------------------------------------------------
				}
				lqb[R][itr] = lqb[F][itr] = 0;
				// ----------------------------------------------------------------------------------------------------------
			}
		}
		
		public char getBase(int direction, int sp) {
			int[] bb = {0, 0, 0, 0};
			for (int i = 0; i < 4; i++) {
				if (p[direction][i][sp] >= 0.05) {
					bb[i] = 1;
				}
			}
			return baseCode[bb[0]][bb[1]][bb[2]][bb[3]];
		}


		public char getMPBase(int direction, int sp) {
			int mpb = 0;
			for (int i = 1; i < 4; i++) {
				if (p[direction][i][sp] > p[direction][mpb][sp]) {
					mpb = i;
				}
			}
			if (p[direction][mpb][sp] > 0.9)
				return Oligo.nucl[mpb];
			else
				return Character.toLowerCase(Oligo.nucl[mpb]);
		}

		public char getRefMPBase(int sp) {
			int iBase = maxRef4[0][sp];
			if(ref_p[maxRef4[0][sp]][sp] < ref_p[maxRef4[1][sp]][sp]) {
				System.err.print(iBase + "\t");
				for (int b = 0; b < 4; b++) {
					System.err.print(ref_p[b][sp] + "\t");
				}
				System.err.println();
			}
			if (ref_p[iBase][sp] < 0.4) {
				iBase = 4;
			}
			return Oligo.nucl[iBase];
		}

		public char getRefBase(int sp) {
			int[] bb = {0, 0, 0, 0};
			for (int i = 0; i < 4; i++) {
				if (ref_p[i][sp] >= 0.05) {
					bb[i] = 1;
				}
			}
			return baseCode[bb[0]][bb[1]][bb[2]][bb[3]];
		}

		public void close() throws Exception {
			while(cnt[TTL][start[0]] > 0 || cnt[F][start[0]] > 0 || cnt[R][start[0]] > 0 || sGapCnt[start[0]] > 0) {
				writeStartPoint0();
			}
			try {
				for(int i = CallSNPs.covered[0].length - 2; i >= 0; i--) {
					CallSNPs.covered[CallSNPs.chr][i] += CallSNPs.covered[CallSNPs.chr][i+1];
				} // 				novelSnps
				writerSNPs.write("sId\tLocation\tRef/Base\tScore1\tScore2\tCoverage\tbidx\tP(A)\tP(C)\tP(G)\tP(T)\n");
				writerSNPs.write("\nNovel SNPs count :\t" + CallSNPs.nSNPsCount[CallSNPs.chr] + "\t" + 
						Parameters.trim(((float) CallSNPs.nSNPsCount[CallSNPs.chr]) * 100 / CallSNPs.countSnps[CallSNPs.chr])+ "%\n");
				writerSNPs.write("Hetero SNPs count:\t" + CallSNPs.hSNPsCount[CallSNPs.chr] + "\t" + 
						Parameters.trim(((float) CallSNPs.hSNPsCount[CallSNPs.chr]) * 100 / CallSNPs.countSnps[CallSNPs.chr])+ "%\n");
				writerSNPs.write("Bidx Average ....:\t" + 
						Parameters.trim(((float) CallSNPs.bidxAvr[CallSNPs.chr]) / CallSNPs.countSnps[CallSNPs.chr]) + "\n");
				writerSNPs.write("\nX coverage .......:\t" + Parameters.trim(((double) CallSNPs.X[CallSNPs.chr][TTL]) / cm.counter) + 
						"\nX coverage Forward:\t" + Parameters.trim(((double) CallSNPs.X[CallSNPs.chr][F]) / cm.counter) +
						"\nX coverage Reverse:\t" + Parameters.trim(((double) CallSNPs.X[CallSNPs.chr][R]) / cm.counter) + "\n\n");
				for(int i = 0; i < CallSNPs.covered[CallSNPs.chr].length; i++) {
					writerSNPs.write("covered% with " + (i+1) + "+ ");
					if (i < 9) 
						writerSNPs.write(" ");
					writerSNPs.write("bases:\t" + Parameters.trim(((double) CallSNPs.covered[CallSNPs.chr][i] * 100) / cm.counter) + "%\n");
				}
				if (Parameters.storeConsensus)
					dos.close();
				dis.close();
				disMap.close();
				writerEdges.close();
				writerSNPs.close();
				if (Parameters.storeCoverage)
					writerCoverage.close();
			} catch (Exception e) {
				System.err.println("Can not close output file:\t" + outFile + "\n" + e);
			}
		}
		
		private void increaseStart(int si, int x) {
			start[si] += x;
			if (start[si] >= circuleSize) {
				start[si] = start[si] % circuleSize;
			}
		}

		private void increase() {
			itr++;
			if (itr >= circuleSize) {
				itr = itr % circuleSize;
			}
		}

		private int olPoint(int i) {
			int ix;
			if (ol.isRC()) {
				ix = ol.size - 1 - i;
			} else {
				ix = i;
			}
			return ix;
		}

		private int prbPoint(int i) {
			int ix;
			if (ol.isRC()) {
				ix = ol.prbSize - 1 - i;
			} else {
				ix = i;
			}
			return ix;
		}
		
		private void loadOligoPoint(int i) {
			int ix = prbPoint(i);
			loadBuffQ(ol.prb[A][ix], ol.prb[C][ix], ol.prb[G][ix], ol.prb[T][ix]);
		}
		
		public void loadOligo() throws Exception {
			if (setOligoStart()) { // compute weight, oPetSize, and oNot. Shift start[0] to the location of ol.start, and fill gap if not isRC()
				for (int i = 0; i < ol.size; i++) {
					updateConsensusPoint(i, TTL);
				}
				for (int i = ol.size; i < ol.prbSize; i++) {
					if (ol.isRC()) {
						updateConsensusPoint(i, R);
					} else {
						updateConsensusPoint(i, F);
					}
				}
			} else {
				System.err.println("ERROR 1: Counter:\t" + counter + "\t" + start[0] + "\t" + ol);
			}
		}
		private boolean setOligoStart() throws Exception { // calc: w, wNot for this ol. Shift start[0] to the location of ol.start, and fill gap if not isRC()
			int g;
			int oPetSize = Math.abs(ol.petSize);
			w = ((1- Parameters.weightFactor) + Parameters.weightFactor * ol.weight);
			wNot = (1 - w) / 4;
			while (counter < ol.start) {				
				writeStartPoint0();
			}
			if (ol.isPET()) {
				if((!ol.isRC() && ol.petSize > 0) || (ol.isRC() && ol.petSize < -1)) {
					g = 0;
					while (g < oPetSize) {
						sGap[cmIndex(g)] += ol.petSize;
						sGapCnt[cmIndex(g)]++;
						g++;
					}
				}
			} else {
				g = 0;
				while (g < ol.size) {
					cntSet[cmIndex(g)]++;
					g++;
				}
			}
			// if (counter > 180837800)
				// System.err.println("Exit setOligoStart:\t" + counter + "\t" + start[0]);
			return true;
		}
	
		private void updateConsensusPoint(int i, int direction) {
			// System.err.println(i + "\t" + ol);
			int idx = cmIndex(i);
			double sum = 0;
			loadOligoPoint(i);
			/*
			if (cnt[direction][idx] > lMoniter[0] && cnt[direction][idx] <= lMoniter[1])
				System.err.println("\n" + cnt[direction][idx] + ":\t" + 
						p[direction][0][idx] + "\t" + p[direction][1][idx] + "\t" + p[direction][2][idx] + "\t" + p[direction][3][idx] + "\t" + (p[direction][3][idx] < 1.0));
			//*/
			// ------------------------------------------------------------------------------------------
			// ------------------------------------------------------------------------------------------
			byte ol_mpb;
			cnt[direction][idx]++;
			if (direction == TTL) { 
				CallSNPs.X[CallSNPs.chr][direction]++;
				// System.err.println(buff[0] + "\t" + buff[1] + "\t" + buff[2] + "\t" + buff[3] + "\t" + maxRef4[0][idx]);
				if (buff[maxRef4[0][idx]] > 0.9) {
					CallSNPs.XT[CallSNPs.chr]++;
				}
				if (buff[maxRef4[0][idx]] < 0.1) {
					CallSNPs.XB[CallSNPs.chr]++;
					ol_mpb = ol.getMPBat(olPoint(i));
					bidx[idx] += ((float) olPoint(i)) / ol.size;
					if(olPoint(i) < Parameters.seedSize && ol.prb[ol_mpb][olPoint(i)] > bestQ1[idx] && 
							(ol.isPET() || Parameters.ETag == Parameters.SET) && ol.weight > 0.95) {
						bestQ1[idx] = ol.prb[ol_mpb][olPoint(i)];
						bestQBase1[idx] = Oligo.nucl[ol_mpb];
					} 
					if(ol.prb[ol_mpb][olPoint(i)] > bestQ2[idx] && ol.weight > 0.8) {
						bestQ2[idx] = ol.prb[ol_mpb][olPoint(i)];
						bestQBase2[idx] = Oligo.nucl[ol_mpb];
					}
					scnt[direction][idx]++;
					for (int b = 0; b < 4; b++) {
						p[direction][b][idx] = p[direction][b][idx] * buff[b];
						sum += p[direction][b][idx];
					}
					for (int b = 0; b < 4; b++) {
						p[direction][b][idx] = p[direction][b][idx] / sum;
					}
					/*
					try {
						Thread.sleep(100);
					} catch (Exception e) {
						
					}
					//*/
				}
			} else {
				CallSNPs.X[CallSNPs.chr][direction]++;
				for (int b = 0; b < 4; b++) {
					p[direction][b][idx] = p[direction][b][idx] * buff[b];
					sum += p[direction][b][idx];
				}
				for (int b = 0; b < 4; b++) {
					p[direction][b][idx] = p[direction][b][idx] / sum;
				}
			}
			// ------------------------------------------------------------------------------------------
			// ------------------------------------------------------------------------------------------
			/*
			if (cnt[direction][idx] > lMoniter[0] + 1 && cnt[direction][idx] <= lMoniter[1] + 1)
				System.err.println(cnt[direction][idx] + ":\t" + 
						p[direction][0][idx] + "\t" + p[direction][1][idx] + "\t" + p[direction][2][idx] + "\t" + p[direction][3][idx] + "\t" + (p[direction][3][idx] < 1.0));
			//*/
		}
		
		private int cmIndex(int i) {
			int x = i + start[0];
			if (x < 0) {
				x += circuleSize;
			} else if (x >= circuleSize) {
				x = x % circuleSize;
			}
			return x;
		}
		
		private void displayCmPoint(int point) {
			if (point >= circuleSize) {
				System.err.println("Point > circuleSize:\t" + point + "\t" + circuleSize);
			} else {
				System.err.println("Location:\t" + counter + "\t" + point);
				if (cnt[0][point] > 0) {
					System.err.print(Math.round(bidx[point] * 100 / cnt[0][point]) + "\t");
				} else {
					System.err.print("-\t");
				}
				if (sGapCnt[point] > 0) {
					System.err.print(Math.round(((float) sGap[point]) / sGapCnt[point]) + "\t");
				} else {
					System.err.print("-\t");
				}
				System.err.println(sGapCnt[point]);
				for (int direction = 0; direction < 1; direction++) {
					System.err.println(cnt[direction][point] + "\t" + p[direction][A][point] + "\t" + p[direction][C][point] + "\t" + p[direction][G][point] + "\t" + p[direction][T][point]);
				}
			}
			System.err.println();
		}
	}

	private circularMap cm;
	
	static void loadQ2P() {
		for (int q = 0; q < 81; q++) {
			q2prb[q] = Parameters.Q2P(q-40);
		}
	}
	
	public Consensus(String fName) throws Exception{
		int lastStart = -100;
		// System.err.println(fName);
		int countReads = 0;
		loadQ2P();
		cm = new circularMap(fName);
		// System.err.println(fName);
		ol = new Oligo();
		of = new OligoFile(Parameters.pathOut + fName + ".um.s.l", "", OligoFile.R);
		while(of.available() > 0) { 
			countReads++;
			of.readOligo(ol);
			if (lastStart > ol.start) {
				System.err.println("lastStart: " + lastStart + "\tol.start: " + ol.start);
			}
			lastStart = ol.start;
			cm.loadOligo();
			if (countReads % 1000000 == 0)
				System.err.println((countReads / 1000000) + " M\t" + ol);
		}
		of.close();
		cm.close();
		System.err.println(Parameters.trim(((double) CallSNPs.X[CallSNPs.chr][TTL]) / cm.counter) + "\t" + 
				Parameters.trim(((double) CallSNPs.X[CallSNPs.chr][F]) / cm.counter)
				+ "\t" + Parameters.trim(((double) CallSNPs.X[CallSNPs.chr][R]) / cm.counter));
	}
	
	public static float q2p(int q) {
		if (q >= -40 && q <= 40) 
			return q2prb[q+40];
		else
			return -1;
	}

	private static boolean readPrb1() throws Exception {
		byte l = -1;
		byte q;
		seq = new Seq();
		seq.size = Parameters.seedSize;
		seq.id  = strInPrb.readInt();
		seq.side = l = strInPrb.readByte();
		seq.prbSize = strInPrb.readShort();
		if (ol.isRC()) {
			if (ol.id1 < 0 ||(ol.id1 == seq.id && ol.getSide() == l)) { 
		    	for (int ii = 0; ii < seq.prbSize; ii++) {
		    		for (int jj = 0; jj < 4; jj++) {
		    			seq._q[0][ii][3 - jj] = q = strInPrb.readByte();
		    			seq.p[ii][comp[jj]] = Parameters.Q2P(q);
		    		}
		    	}
				start = ol.start + ol.size - Parameters.seedSize;
		    	return true;
			} else {
		    	for (int ii = 0; ii < seq.prbSize; ii++) {
	    			strInPrb.readInt();
		    	}	
			}
			if (ol.id1 > seq.id) {
				System.err.println("\t<prb:\t" + seq.id + ", " + l + ">\t,Target:\t" + ol.id1 + "\t" + ol.getSide());
				Thread.sleep(2000);
			}
	    	return false;
		} else {
			if (ol.id1 < 0 ||(ol.id1 == seq.id && ol.getSide() == l)) { 
		    	for (int ii = 0; ii < seq.prbSize; ii++) {
		    		for (int jj = 0; jj < 4; jj++) {
		    			seq._q[0][ii][jj] = q = strInPrb.readByte();
		    			seq.p[ii][jj] = Parameters.Q2P(q); 
		    		}
		    	}
				start = ol.start;
		    	return true;
			} else {
		    	for (int ii = 0; ii < seq.prbSize; ii++) {
	    			strInPrb.readInt();
		    	}	
			}
			if (ol.id1 > seq.id) {
				System.err.println("\t<prb:\t" + seq.id + ", " + l + ">\t,Target:\t" + ol.id1 + "\t" + ol.getSide());
				Thread.sleep(2000);
			}
	    	return false;
		}
	}

	public static void prbLoad() throws Exception {
		String line;
		StringTokenizer st;
		String stk;
		int sz;
		try {
			BufferedReader readerQCAL2 = new BufferedReader(new FileReader(Parameters.pathOut + "prbCal2d"));
			System.err.println("Loading " + Parameters.pathOut + "prbCal2d");
			readerQCAL2.readLine();
			for (int qp40 = 0; qp40 < 81; qp40++) {
				line = readerQCAL2.readLine();
				st = new StringTokenizer(line);
				sz = st.countTokens() - 2;
				stk = st.nextToken();
				stk = st.nextToken();
				for (int i = 0; i < sz; i++) {
					stk = st.nextToken();
					iq2qCal[i][qp40] = new Integer(stk).intValue();
				}
				for (int i = 0; i < sz; i++) {
					System.err.print("\t" + iq2qCal[i][qp40]);
				}
				System.err.println("\n" + line);
			}
			readerQCAL2.close();
		} catch (Exception e) {
			System.err.println("No qCal file found, generating " + Parameters.pathOut + "prbCal2d");
			prbCall();
		}
	}
	
	public static void prbCall() throws Exception {
		long countReads = 0;
		long countExtra = 0;
		int prbPoint;
		int bs;
		for (int i1 = 0; i1 < 2; i1++)
			for (int i2 = 0; i2 < 93; i2++)
				for (int i3 = 0; i3 < 81; i3++)
					prbCal[i1][i2][i3] = 0;
		ol = new Oligo();
		int prbSizeMax = Parameters.seedSize;
		strInPrb = new DataInputStream(new BufferedInputStream(new FileInputStream(Parameters.pathData + Parameters.outFile + ".prb"), 256000));
		of    = new OligoFile(Parameters.pathOut + "s.e.m0.s.id", "", OligoFile.R); 
		while(of.available() > 0) {
			countReads++;
			of.readOligo(ol);
			if (countReads % 1000000 == 0) {
				System.err.println("Read:\t" + countReads/1000000 + "M");
			}
			if (countReads % 2 == 0) {
				if (!ol.isLQ() && ol.size > (Parameters.seedSize + 2) && ol.weight > 0.8 && ol.isU0() && ol.isUM()) {
					while(!readPrb1());
					if (seq.prbSize > prbSizeMax)
						prbSizeMax = seq.prbSize;
					for (int i2 = 0; i2 < ol.size; i2++) { 
						if (ol.isRC()) { 
							prbPoint = ol.size - 1 - i2; 
						} else {
							prbPoint = i2;
						}
						bs = Oligo.getBpInt(ol.getBPat(i2), 1); // i2
						for (int b = 0; b < 4; b++) {
							if (b == bs)
								prbCal[0][prbPoint][seq._q[0][prbPoint][b]+40]++;
							else
								prbCal[1][prbPoint][seq._q[0][prbPoint][b]+40]++;
						}
					} 
					for (int i2 = ol.size; i2 < seq.prbSize; i2++) {
						bs = Oligo.getBpInt(ol.getBPat(i2), 1); // i2
						countExtra++;
						for (int b = 0; b < 4; b++) {
							if (b == bs)
								prbCal[0][i2][seq._q[0][i2][b]+40]++;
							else
								prbCal[1][i2][seq._q[0][i2][b]+40]++;
						}
					}
				} // end reading from oligoFile
			}
		}
		of.close();
		strInPrb.close();
		System.err.println("Bases after size:\t" + countExtra);

		float tmp;
		float [][] prbCal1 = new float[2][101];
		BufferedWriter writerQCAL2 = new BufferedWriter(new FileWriter(Parameters.pathOut + "prbCal2d"));
		BufferedWriter writerQCAL1 = new BufferedWriter(new FileWriter(Parameters.pathOut + "prbCal1d"));
		writerQCAL2.write("Q\tP");
		for (int i2 = 0; i2 < prbSizeMax; i2++) 
			writerQCAL2.write("\t" + i2);
		writerQCAL2.write("\n");
		//*
		for (int q40 = 0; q40 < 81; q40++) {
			for (int i2 = 0; i2 < prbSizeMax; i2++) { // Parameters.seedSize
				if (prbCal[0][i2][q40] + prbCal[1][i2][q40] > 100)
					iq2prb[i2][q40] = (float) (prbCal[0][i2][q40] / (prbCal[0][i2][q40] + prbCal[1][i2][q40]));		
				else
					iq2prb[i2][q40] = Parameters.Q2P(Parameters.defalutQ(i2, q40-40));
				if ((q40-40) > 20 && iq2prb[i2][q40] > Parameters.Q2P(Parameters.defalutQ(i2, q40-40)))
					iq2prb[i2][q40] = Parameters.Q2P(Parameters.defalutQ(i2, q40-40));
				else if ((q40-40) < -20 && iq2prb[i2][q40] < Parameters.Q2P(Parameters.defalutQ(i2, q40-40)))
					iq2prb[i2][q40] = Parameters.Q2P(Parameters.defalutQ(i2, q40-40));
			}
		}
		//*/
		for (int i3 = 0; i3 < 81; i3++) {
			prbCal1[0][i3] = prbCal1[1][i3] = 0;
			writerQCAL2.write((i3 - 40) + "\t" + Parameters.trim(Parameters.Q2P(i3-40) * 100) + "\t");
			for (int i2 = 0; i2 < prbSizeMax; i2++) { // Parameters.seedSize
				iq2qCal[i2][i3] = Parameters.P2Q(iq2prb[i2][i3]);
				writerQCAL2.write(getQCal(i3-40, i2) + "\t");
				prbCal1[0][i3] += prbCal[0][i2][i3];
				prbCal1[1][i3] += prbCal[1][i2][i3];
			}
			if (prbCal1[0][i3] + prbCal1[1][i3] > 100)
				tmp = prbCal1[0][i3] / (prbCal1[0][i3] + prbCal1[1][i3]);
			else
				tmp = 0;
			writerQCAL1.write((i3 - 40) + "\t" + Parameters.trim(Parameters.Q2P(i3-40) * 100) + 
					"\t" + Parameters.P2Q(tmp) + "\t" + Parameters.trim(tmp * 100) + "\n");
			writerQCAL2.write("\n");
		}
		writerQCAL2.close();
		writerQCAL1.close();
	}
	
	private void readqcall2() throws Exception {
		BufferedReader readerQCAL2 = new BufferedReader(new FileReader(Parameters.pathOut + "prbCal2d"));
		String line = readerQCAL2.readLine();
		
		readerQCAL2.close();
	}
	
	public static int getQCal(int q, int i) {
		return iq2qCal[i][q+40];
	}
	private static void displayOlSeq() throws Exception {
		//*
		System.err.println(ol);
		for (int i = 0; i < seq.prbSize; i++) {
			for (int b = 0; b < 4; b++) {
				System.err.print(Parameters.trim(seq._q[0][i][b]) + " ");
			}
			System.err.print("\t");
		}
		System.err.println();
		Thread.sleep(3000);
		//*/
	}

}
