// package JavaCode;

import java.util.StringTokenizer;

public class Edge {
	private Location location;
	private char  direction;
	private byte  bidx;
	private int   support;
	private int   cover;
	private short gap;
	private int   gapSupport;
	private short map;
	
	// Id\tLocation\tDirection\tBIdx\tSupport\tCover\tSpan\tSpanSupport\tMap
	public Edge(String line, int chr) {
		StringTokenizer st = new StringTokenizer(line);
		st.nextToken();
		location  =         new Location(chr, new Integer(st.nextToken()).intValue());
		direction = ((String) st.nextToken()).charAt(0);
		bidx      = (byte)  new Integer(st.nextToken()).intValue();
		support   =         new Integer(st.nextToken()).intValue();
		cover     =         new Integer(st.nextToken()).intValue();
		gap       = (short) new Integer(st.nextToken()).intValue();
		gapSupport=         new Integer(st.nextToken()).intValue();
		map       = (short) new Integer(st.nextToken()).intValue();

		st.nextToken();
		// score     = new Float(st.nextToken()).floatValue();
	}
	
	public Edge(Edge e) {
		location  = new Location(e.location);
		direction = e.direction;
		bidx      = e.bidx;
		support   = e.support;
		cover     = e.cover;
		gap       = e.gap;
		gapSupport= e.gapSupport;
		map       = e.map;
	}
	public Edge(Location location, char direction, byte bidx, int support, int cover, short span, int gapSupport, short map)	{
		this.location  = new Location(location);
		this.direction = direction;
		this.bidx      = bidx;
		this.support   = support;
		this.cover     = cover;
		this.gap       = span;
		this.gapSupport= gapSupport;
		this.map       = map;
	}
	
	public Location getLocation() {
		return location;
	}
	public void setLocation(Location location) {
		this.location = new Location(location);
	}
	public char getDirection() {
		return direction;
	}
	public void setDirection(char direction) {
		this.direction = direction;
	}
	public short getMap() {
		return map;
	}
	public void setMap(short map) {
		this.map = map;
	}
	public short getGap() {
		return gap;
	}
	public void setGap(int g) {
		this.gap = (short) g;
	}
	public int getGSupport() {
		return gapSupport;
	}
	public void setGSupport(int gs) {
		this.gapSupport = gs;
	}
	public int getSupport() {
		return support;
	}
	public void setSupport(int s) {
		this.support = s;
	}
	public int getCover() {
		return cover;
	}
	public void setCover(int c) {
		this.cover = c;
	}
	public int getBIdx() {
		return bidx;
	}
	public void setBIdx(int bi) {
		bidx = (byte) bi;
	}
}
