// package JavaCode;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;

public class ScoreSNPs11 {
	static String file;
	static BufferedWriter writerSNPs;
	static BufferedReader readerSNPs;
	static float[] X = new float[100];
	static int[][][] rank_Bidx    = new int[3][15][101]; 
	static int[][] rankKScore  = new int[3][101]; 
	static int[][] rankUKScore = new int[3][101]; 
	static int[] scoreFinal  = new int[101];
	static boolean known = true;
	static int[][] countKnown = new int[3][101];
	static int[][] countUKnown = new int[3][101];

	/**
	 * @param args
	 */
	static char ref;
	static char mpb;
	static char bqb1;
	static char bqb2;
	static int bq1;
	static int bq2;
	static int cnt;
	static int scnt;
	static int rcnt;
	static int suk;
	static int sk;
	static int bidx;
	static int tScore;
	static int rank;
	static int H;

	static int unPack(String line, int ch) {
		String stk;
		StringTokenizer st;
		st = new StringTokenizer(line);
		if (st.hasMoreTokens()) {
			stk = st.nextToken();
			if (stk.charAt(0) == 's')
				return 2;
			stk = st.nextToken();
			stk = st.nextToken();
			ref = stk.charAt(0);
			stk = st.nextToken();
			mpb = stk.charAt(0);
			stk = st.nextToken();
			sk  = new Integer(stk).intValue();
			stk = st.nextToken();
			suk = new Integer(stk).intValue();
			stk = st.nextToken();
			rcnt = new Integer(stk).intValue();
			stk = st.nextToken();
			scnt = cnt = new Integer(stk).intValue();
			stk = st.nextToken();
			bidx = new Integer(stk).intValue();
			if (bidx > 100)
				bidx = 100;
			if (bidx < 0)
				bidx = 0;
			if (cnt > 14)
				cnt = 14;
			if (cnt < 0)
				cnt = 0;
			stk = st.nextToken();
			bq1 = new Integer(stk).intValue();
			stk = st.nextToken();
			bqb1 = stk.charAt(0);
			stk = st.nextToken();
			bq2 = new Integer(stk).intValue();
			stk = st.nextToken();
			bqb2= stk.charAt(0);
			stk = st.nextToken();
			stk = st.nextToken();
			stk = st.nextToken();
			stk = st.nextToken();
			if (st.nextToken().charAt(0) == 'K') {
				known = true;
			} else {
				known = false;
			}
			if (scnt * 3 >= rcnt * 2)
				H = 1;
			else
				H = 2;
			// if (mpb1 == ref || mpb1 == '-' || bq1 < 26) {
			if (bqb1 != ref && bqb1 != '-'  && bq1 >= 26) { // best
				rank = 0;
			} else {
				if (bqb2 != ref && bqb2 != '-' && bq2 >= 22) //rcnt > Parameters.seedSize / 2 && mpb1 == '-')
					rank = 1;
				else 
					rank = 2;
			}
			// } else {
				// rank = 0;
			// }
			if (rcnt > 7 * X[ch]) {
				rank += 3;
			} else if (rcnt > 4 * X[ch]) {
				rank += 2;
			} else if (rcnt > 2 * X[ch]) {
				rank++;
			}
			if (scnt * 4 < rcnt * 3)
				rank++;
			return 0;
		} else {
			return 1;
		}

	}
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		int[][] sum_Bidx    = new int[3][15];
		int[] sumScoreUK = {0, 0, 0};
		int[] sumScoreK  = {0, 0, 0};
		int sumScoreFinal = 0;
		String line;
		int ret;
		Parameters.resetTime();
		if (args.length < 1) {
			System.err.println("Please supply a configuration file");
			return;
		}
		Parameters.read(args[0]);
		if(!(new File(Parameters.pathOut + "/filter")).mkdir()) {
			System.err.println("Error creating the directory " + Parameters.pathOut + "/filter");
		}
		for (int c = 0; c < 15; c++) {
			for (int r = 0; r < 3; r++) {
				sum_Bidx[r][c] = 0;
			}
		}
		for (int i = 0; i < 101; i++) {
			for (int c = 0; c < 15; c++) {
				for (int r = 0; r < 3; r++) {
					rank_Bidx[r][c][i] = 0;
				}
			}
			scoreFinal[i]  = rankKScore[0][i] = rankUKScore[0][i] = rankKScore[1][i] = rankUKScore[1][i] = rankKScore[2][i] = rankUKScore[2][i] = 0;
			countUKnown[0][i] = countKnown[0][i] = countUKnown[1][i] = countKnown[1][i] = countUKnown[2][i] = countKnown[2][i] = 0;
		}
		String stk;
		BufferedReader readerX = new BufferedReader(new FileReader(Parameters.pathOut + "report.snps"));
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			line = readerX.readLine();
			StringTokenizer st = new StringTokenizer(line);
			stk = st.nextToken();
			stk = st.nextToken();
			stk = st.nextToken();
			X[i] = new Float(stk).floatValue();
			System.err.println(X[i]);
		}
		readerX.close();
		// ------------------------------------------------------------------- start ranking
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			file       = Parameters.ch_name1 + Parameters.SEQ_VAR[i] + Parameters.ch_name2;
			System.err.println(file);
			readerSNPs = new BufferedReader(new FileReader(Parameters.pathOut + file + ".snps"));
			while (true) {
				line = readerSNPs.readLine();
				ret = unPack(line, i);
				if (ret == 0) {
					if (rank < 3){
						rankKScore[rank][sk]++;
						rankUKScore[rank][suk]++;
						rank_Bidx[rank][cnt][bidx]++;
						// System.err.print('.');
					}
				} else {
					break;
				}
			}
			readerSNPs.close();
		}
		// ------------------------------------------------------------------- End ranking
		for (int i = 0; i < 101; i++) {
			// ------------------------------------ start summing scores for each rank
			for (int c = 0; c < 15; c++) {
				for (int r = 0; r < 3; r++) {
					sum_Bidx[r][c] += rank_Bidx[r][c][i];
				}
			}
			for (int r = 0; r < 3; r++) {
				sumScoreK[r] += rankKScore[r][i];
				sumScoreUK[r] += rankUKScore[r][i];
			}
		}
		// ---------------------------------------- end summing scores for each rank
		// ------------------------------------------------------------------- start accumulating ranking
		for (int i = 1; i < 101; i++) {
			for (int c = 0; c < 15; c++) {
				for (int r = 0; r < 3; r++) {
					rank_Bidx[r][c][i]    += rank_Bidx[r][c][i - 1];
				}
			}
			for (int r = 0; r < 3; r++) {
				rankKScore[r][i]  += rankKScore[r][i - 1];
				rankUKScore[r][i] += rankUKScore[r][i - 1];
			}
		}			
		// ------------------------------------------------------------------- end accumulating ranking
		// ------------------------------------------------------------------- start % ranking
		for (int i = 0; i < 101; i++) {
			for (int r = 0; r < 3; r++) {
				rankKScore[r][i]  = Math.round(((float) rankKScore[r][i]) * 100 / sumScoreK[r]);
				rankUKScore[r][i] = Math.round(((float) rankUKScore[r][i]) * 100 / sumScoreUK[r]);
			}
			for (int c = 0; c < 15; c++) {
				for (int r = 0; r < 3; r++) {
					rank_Bidx[r][c][i] = Math.round(((float) rank_Bidx[r][c][i]) * 100 / sum_Bidx[r][c]);
				}
			}
		}
		// ------------------------------------------------------------------- end % ranking
		// ------------------------------------------------------------------- start display % ranking
		System.err.print("Totals:\t" + sumScoreK[0] + "\t" + sumScoreUK[0]);	
		for (int c = 0; c < 15; c++) {
			System.err.print("\t" + sum_Bidx[0][c]);
		}
		System.err.println();
		for (int i = 0; i < 101; i++) {
			System.err.print(i + "\t" + rankKScore[0][i] + "\t" + rankUKScore[0][i]);	
			for (int c = 0; c < 15; c++) {
				System.err.print("\t" + rank_Bidx[0][c][i]);
			}
			System.err.println();
		}
		// ------------------------------------------------------------------- end display % ranking
		// ----------------------------------------------------------------------------------
		int score;
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			file       = Parameters.ch_name1 + Parameters.SEQ_VAR[i] + Parameters.ch_name2;
			readerSNPs = new BufferedReader(new FileReader(Parameters.pathOut + file + ".snps"));
			while (true) {
				line = readerSNPs.readLine();
				score = getFinalScore(line, i);
				if (score < 0)
					break;
				if (score <= 100)
					scoreFinal[score]++;
			}
			readerSNPs.close();
		}
		
		for (int i = 0; i < 101; i++) {
			sumScoreFinal += scoreFinal[i];
			if (i > 0) {
				scoreFinal[i]  += scoreFinal[i - 1];
			}
		}			
		for (int i = 0; i < 101; i++) {
			scoreFinal[i]  = Math.round(((float) scoreFinal[i]) * 100 / sumScoreFinal);
		}
		System.err.println("Final\t" + sumScoreFinal);	
		for (int i = 0; i < 101; i++) {
			System.err.println(i + "\t" + scoreFinal[i]);	
		}
		// ----------------------------------------------------------------------------------
		
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			file       = Parameters.ch_name1 + Parameters.SEQ_VAR[i] + Parameters.ch_name2;
			readerSNPs = new BufferedReader(new FileReader(Parameters.pathOut + file + ".snps"));
			writerSNPs = new BufferedWriter(new FileWriter(Parameters.pathOut + "/filter/" + file + ".snps"));
			
			while (true) {
				line = readerSNPs.readLine();
				score = getNormalizedFinalScore(line, i);
				if (score < 0)
					break;
				if (score <= 100 && rank < 3) {
					if (known)
						countKnown[0][score]++;
					else
						countUKnown[0][score]++;
					writerSNPs.write(score + "\t" + line);
					if (H == 1)
						writerSNPs.write("\tH1\n");
					else
						writerSNPs.write("\tH2\n");
				}
			}
			readerSNPs.close();
			writerSNPs.close();
		}
		System.err.println("Novel\tKnown");
		for (int i = 0; i < 101; i++) {
			System.err.println(i + "\t" + countUKnown[0][i] + "\t" + countKnown[0][i]);	
		}
	}
	
	// static final float rto = 2f;
	static private int join_Scores(int s1, int s2, int count, float rto) {
		float lg = (float) (Math.log(count)/ Math.log(10));
		if (lg >= rto)
			lg = rto;
		return (int) Math.round((s2 * lg + s1 * (rto - lg) + 100 * scnt / rcnt) / (rto + 1)); 		
	}

	static private int getFinalScore(String line, int ch) {
		int ret;
		int joinedScore;
		int score2;
		int score1;
		ret = unPack(line, ch);
		if (ret == 0) {
			if (rank < 3) { // rank_Bidx[r][c][i]
				if (rank_Bidx[rank][cnt][bidx] > Parameters.snpBidxCenter + Parameters.snpBidxSprd) {
					score2 = 100 - ((rank_Bidx[rank][cnt][bidx] - (Parameters.snpBidxCenter + Parameters.snpBidxSprd)) * 99 / (100 - (Parameters.snpBidxCenter + Parameters.snpBidxSprd)) );
					// score2 = 2 * (Parameters.snpBidxCenter + 20) - rank_Bidx[rank][cnt][bidx];
					if (score2 < 1)
						score2 = 1;
				} else if (rank_Bidx[rank][cnt][bidx] < Parameters.snpBidxCenter - Parameters.snpBidxSprd) {
					score2 = rank_Bidx[rank][cnt][bidx] * 99 / (Parameters.snpBidxCenter - Parameters.snpBidxSprd);
				} else {
					score2 = 99;
				}
				score1 = rankKScore[rank][sk];
				switch(rank) {
				case 0:
					joinedScore = join_Scores(score1, score2, cnt, 2.2f);
					if (joinedScore > 100 || joinedScore < 0) {
						System.err.println("Ret:\t" + joinedScore);
					}
					return joinedScore / 2 + 50;
				case 1:
					joinedScore = join_Scores(score1, score2, cnt, 2.2f);
					if (joinedScore > 100 || joinedScore < 0) {
						System.err.println("Ret:\t" + joinedScore);
					}
					return joinedScore / 4 + 25;				
				case 2:
					joinedScore = join_Scores(score1, score2, cnt, 2f);
					if (joinedScore > 100 || joinedScore < 0) {
						System.err.println("Ret:\t" + joinedScore);
					}
					return joinedScore / 4;
				case 3:
					return 101;
				default:
					return -1;
				}
			} else {
				return 101;
			}
		} else {
			return -1;
		}
	}
	
	static private int getNormalizedFinalScore(String line, int ch) {
		int score = getFinalScore(line, ch);
		if (score > 100) {
			return score;
		} else if (score >= 0) {
			return scoreFinal[score];
		} else {
			return -1;
		}
	}
	
}
